local T, C, L = unpack(select(2, ...))

T.nivStatsContext = UI.CreateContext("nivStatsContext")
T.nivStatsBar = UI.CreateFrame("Frame", "nivStatsMainBar", T.nivStatsContext)
T.mover = UI.CreateFrame("Frame", "nivStatsMover", T.nivStatsContext)
T.sizer = UI.CreateFrame("Frame", "nivStatsSizer", T.nivStatsContext)
T.moverTT = UI.CreateFrame("Text", "nivStatsMoverTT", T.nivStatsContext)
T.sizerTT = UI.CreateFrame("Text", "nivStatsSizerTT", T.nivStatsContext)

local config = {}
T.modules = {}
local modlock = true
T.nivStatsConfig = function()

	config.anchor = C["general"].anchor
	config.anchorTo = C["general"].anchorTo
	config.width = C["general"].defaultWidth
	config.height = C["general"].defaultHeight
	config.x = C["general"].defaultX
	config.y = C["general"].defaultY
	config.layer = C["general"].defaultLayer
	
	T.nivStats_spawnBar()

end


function T.nivStats_spawnBar()
	T.nivStatsBar:ClearAll()
	if config.anchor == true then
		if config.anchorTo == "top" then
			T.nivStatsBar:ClearAll()
			T.nivStatsBar:SetPoint("TOPLEFT", UIParent, "TOPLEFT", 0, 0)
		elseif config.anchorTo == "bottom" then
			T.nivStatsBar:ClearAll()
			T.nivStatsBar:SetPoint("BOTTOMLEFT", UIParent, "BOTTOMLEFT", 0, 0)
		else
			T.nivStatsBar:ClearAll()
			T.nivStatsBar:SetPoint("TOPLEFT", UIParent, "TOPLEFT", 0, 0)
		end
		T.nivStatsBar:SetWidth(config.width)
	else
		T.nivStatsBar:ClearAll()
		T.nivStatsBar:SetPoint("TOPLEFT", UIParent, "TOPLEFT", config.x, config.y)
		T.nivStatsBar:SetWidth(config.width)
	end
	T.nivStatsBar:SetBackgroundColor(0,0,0,.5)
	T.nivStatsBar:SetHeight(config.height)
	T.nivStatsBar:SetLayer(config.layer)
end

local function nivStats_Save()
	nivStats_anchor = config.anchor
	nivStats_anchorTo = config.anchorTo
	nivStats_anchorX = config.x
	nivStats_anchorY = config.y
	nivStats_width = config.width
	nivStats_height = config.height
	nivStats_layer = config.layer
end

local function nivStats_Load()
	if nivStats_width then
		config.anchor = nivStats_anchor
		config.anchorTo = nivStats_anchorTo
		config.width = nivStats_width
		config.height = nivStats_height
		config.x = nivStats_anchorX
		config.y = nivStats_anchorY
		config.layer = nivStats_layer
		T.nivStats_spawnBar()
	else
		T.nivStatsConfig()
	end
	for k,v in pairs(Event.Addon.SavedVariables.Load.End) do
		if v[2] == "nivStats" then
			eventID = k
		end
	end
	table.remove(Event.Addon.SavedVariables.Load.End, eventID)
end

local function anchorOff()
	config.anchor = false
	T.nivStats_spawnBar()
end
local function anchorTop()
	config.anchor = true
	config.anchorTo = "top"
	config.width = C["general"].defaultWidth
	T.nivStats_spawnBar()
end	
local function anchorBottom()
	config.anchor = true
	config.anchorTo = "bottom"
	config.width = C["general"].defaultWidth
	T.nivStats_spawnBar()
end
local function unlock()
	anchorOff()

	T.mover:SetPoint("TOPLEFT", UIParent, "TOPLEFT", T.nivStatsBar:GetLeft(), T.nivStatsBar:GetTop())
	T.mover:SetHeight(10)
	T.mover:SetWidth(10)
	T.mover:SetBackgroundColor(1, 1, 1, .5)
	T.mover:SetLayer(20)
	T.mover:SetVisible(true)
	T.mover.Event.MouseIn = function(...) T.moverMousein() end
	T.mover.Event.MouseOut = function(...) T.moverMouseout() end
	
	T.sizer:SetPoint("BOTTOMRIGHT", UIParent, "TOPLEFT", T.nivStatsBar:GetRight(), T.nivStatsBar:GetBottom())
	T.sizer:SetHeight(10)
	T.sizer:SetWidth(10)
	T.sizer:SetBackgroundColor(1, 1, 1, .5)
	T.sizer:SetLayer(20)
	T.sizer:SetVisible(true)
	T.sizer.Event.MouseIn = function(...) T.sizerMousein() end
	T.sizer.Event.MouseOut = function(...) T.sizerMouseout() end
end
local function lock()
	T.mover:ClearAll()
	T.mover:SetBackgroundColor(0,0,0,0)
	T.mover:SetLayer(1)
	T.mover:SetVisible(false)
	
	T.sizer:ClearAll()
	T.sizer:SetBackgroundColor(0,0,0,0)
	T.sizer:SetLayer(1)
	T.sizer:SetVisible(false)
end
T.moverMousein = function()
	T.moverTT:SetPoint("BOTTOMLEFT", T.mover, "TOPLEFT", 0, 0)
	T.moverTT:SetText("Move Me!")
	T.moverTT:SetVisible(true)
end
T.moverMouseout = function()
	T.moverTT:SetText("")
	T.moverTT:SetVisible(false)
end
T.sizerMousein = function()
	T.sizerTT:SetPoint("TOPRIGHT", T.sizer, "BOTTOMRIGHT", 0, 0)
	T.sizerTT:SetText("Size Me!")
	T.sizerTT:SetVisible(true)
end
T.sizerMouseout = function()
	T.sizerTT:SetText("")
	T.sizerTT:SetVisible(false)
end
local function unlockMods()
	modlock = false
end
local function lockMods()
	modlock = true
end

local function justWords(str)
  local t = {}
  local function helper(word) table.insert(t, word) return "" end
  if not str:gsub("%w+", helper):find"%S" then return t end
end

local function ns(paramEntry)

	local param = {}
	param = justWords(paramEntry)

	if param[1] ~= "unlock" and param[1] ~= "lock" and param[1] ~= "anchor" then
		dump("Available Commands")
		dump("---unlock: must be followed by \"bar\" or \"mods\"")
		dump("---lock: must be followed by \"bar\" or \"mods\"")
		dump("---anchor: locks the bar to the given anchor. must be followed with \"top\" or \"bottom\"")
	elseif param[1] == "unlock" then
		if param[2] ~= "bar" and param[2] ~= "mods" then
			dump("To unlock the main bar use /ns unlock bar")
			dump("To unlock the modules use /ns unlock mods")
		elseif param[2] == "bar" then
			unlock()
		else
			unlockMods()
		end
	elseif param[1] == "lock" then
		if param[2] ~= "bar" and param[2] ~= "mods" then
			dump("To lock the main bar use /ns lock bar")
			dump("To lock the modules use /ns lock mods")
		elseif param[2] == "bar" then
			lock()
		else
			lockMods()
		end
	else
		if param[2] ~= "top" and param[2] ~= "bottom" then
			dump("To anchor the bar to the top of the screen use /ns anchor top")
			dump("To anchor the bar to the bottom of the screen use /ns anchor bottom")
		elseif param[2] == "top" then
			anchorTop()
		else
			anchorBottom()
		end 
	end

end



local function AddDragFrame(window)

  function window.Event:LeftDown()
    self.leftDown = true
    local mouse = Inspect.Mouse()
    self.originalXDiff = mouse.x - self:GetLeft()
    self.originalYDiff = mouse.y - self:GetTop()
    local left, top, right, bottom = window:GetBounds()
    window:ClearAll()
    window:SetPoint("TOPLEFT", UIParent, "TOPLEFT", left, top)
    window:SetWidth(right-left)
    window:SetHeight(bottom-top)
  end

  function window.Event:LeftUp()
    self.leftDown = false
  end

  function window.Event:LeftUpoutside()
    self.leftDown = false
  end

  function window.Event:MouseMove(x, y)
    if not self.leftDown then
      return
    end
    
	if window == T.mover then
		window:SetPoint("TOPLEFT", UIParent, "TOPLEFT", x - self.originalXDiff, T.nivStatsBar:GetTop())
		T.nivStatsBar:SetPoint("TOPLEFT", UIParent, "TOPLEFT", x - self.originalXDiff, y - self.originalYDiff)
		T.sizer:ClearAll()
		T.sizer:SetPoint("BOTTOMRIGHT", UIParent, "TOPLEFT", T.nivStatsBar:GetRight(), T.nivStatsBar:GetBottom())
		T.sizer:SetHeight(10)
		T.sizer:SetWidth(10)
		config.x = T.nivStatsBar:GetLeft()
		config.y = T.nivStatsBar:GetTop()
	elseif window == T.sizer then
		window:ClearAll()
		window:SetPoint("BOTTOMRIGHT", UIParent, "TOPLEFT", (x - self.originalXDiff) + window:GetWidth(), T.nivStatsBar:GetBottom())
		window:SetHeight(10)
		window:SetWidth(10)
		T.nivStatsBar:SetWidth(T.sizer:GetRight() - T.nivStatsBar:GetLeft())
		config.width = T.nivStatsBar:GetWidth()
	end
  end
end
AddDragFrame(T.mover)
AddDragFrame(T.sizer)
T.AddDragFrameMods = function(window)

	function window.Event:LeftDown()
		self.leftDown = true
		local mouse = Inspect.Mouse()
		self.originalXDiff = mouse.x - self:GetLeft()
		self.originalYDiff = mouse.y - self:GetTop()
		local left, top, right, bottom = window:GetBounds()
		window:ClearAll()
		window:SetPoint("TOPLEFT", UIParent, "TOPLEFT", left, top)
		window:SetWidth(right-left)
		window:SetHeight(bottom-top)
	end

	function window.Event:LeftUp()
		self.leftDown = false
	end

	function window.Event:LeftUpoutside()
		self.leftDown = false
	end

	function window.Event:MouseMove(x, y)
		if not self.leftDown then
		  return
		end
		if modlock then
			return
		end
		local left, top, right, bottom = window:GetBounds()
		local left1, top1, right1, bottom1 = T.nivStatsBar:GetBounds()
		local pointY = top - top1
		if T.nivStatsBar:GetLeft() > x - self.originalXDiff then
			window:ClearAll()
			window:SetPoint("CENTERLEFT", T.nivStatsBar, "CENTERLEFT", 0, 0)
		elseif T.nivStatsBar:GetRight() - window:GetWidth() < x - self.originalXDiff then
			window:ClearAll()
			window:SetPoint("CENTERRIGHT", T.nivStatsBar, "CENTERRIGHT", 0, 0)
		else
			window:ClearAll()
			window:SetPoint("CENTERLEFT", T.nivStatsBar, "CENTERLEFT", (x - self.originalXDiff) - left1, 0)
		end
	end
end


table.insert(Event.Addon.SavedVariables.Save.Begin, {nivStats_Save, "nivStats", "Save"})
table.insert(Event.Addon.SavedVariables.Load.End, {nivStats_Load, "nivStats", "Load"})

table.insert(Command.Slash.Register("ns"), {ns, "nivStats", "nivStats slash commands"})