local addon = ...
local T, C, L = unpack(nivStats)

T.modules.bagFrame = UI.CreateFrame("Text", "Bag Slots", T.nivStatsBar)
local bagFrame = T.modules.bagFrame
bagFrame:SetPoint("CENTERLEFT", T.nivStatsBar, "CENTERLEFT", 0, 0)
bagFrame:SetLayer(2)
T.AddDragFrameMods(T.modules.bagFrame)

function bagSlots()
	slotInfo = Inspect.Item.List()
	totalSlots = 0
	emptySlots = 0

	for k, v in pairs(slotInfo) do
		if string.sub(k, 0, 2) == "si" and string.sub(k, 3, 4) ~= "bg" then
			totalSlots = totalSlots + 1
			if v == false then
				emptySlots = emptySlots + 1
			end
		end
	end
	--Place the count on the bar
	bagSlotString = string.format("B: %d/%d", emptySlots, totalSlots)
	bagFrame:SetText(bagSlotString)

	for k,v in pairs(Event.System.Update.End) do
		if v[2] == "nivStatsBags" then
			eventID = k
		end
	end
	table.remove(Event.System.Update.End, eventID)
end

local function onLoad()
	if nivStatsBags_frameX then
		bagFrame:ClearAll()
		bagFrame:SetPoint("TOPLEFT", T.nivStatsBar, "TOPLEFT", nivStatsBags_frameX, nivStatsBags_frameY)
	else
		bagFrame:ClearAll()
		bagFrame:SetPoint("CENTERLEFT", T.nivStatsBar, "CENTERLEFT", 0, 0)
	end
	for k,v in pairs(Event.Addon.SavedVariables.Load.End) do
		if v[2] == "nivStatsBags" then
			eventID = k
		end
	end
	table.remove(Event.Addon.SavedVariables.Load.End, eventID)
end

local function onSave()
	nivStatsBags_frameX = bagFrame:GetLeft() - T.nivStatsBar:GetLeft()
	nivStatsBags_frameY = bagFrame:GetTop() - T.nivStatsBar:GetTop()
end
table.insert(Event.Addon.SavedVariables.Save.Begin, {onSave, "nivStatsBags", "Save"})
table.insert(Event.Addon.SavedVariables.Load.End, {onLoad, "nivStatsBags", "Load"})

table.insert(Event.System.Update.End, { bagSlots, "nivStatsBags", "Refresh Modules" })
table.insert(Event.Item.Slot, { bagSlots, "nivStatsBags", "Refresh Modules" })
table.insert(Event.Item.Update, { bagSlots, "nivStatsBags", "Refresh Modules" })



