local addon = ...
local T, C, L = unpack(nivStats)

T.modules.currencyFrame = UI.CreateFrame("Frame", "nivStatsCurrencyMain", T.nivStatsBar)
T.AddDragFrameMods(T.modules.currencyFrame)
local currencyFrame = T.modules.currencyFrame
	currencyFrame:SetPoint("CENTER", T.nivStatsBar, "CENTER", 0, 0)
	currencyFrame:SetHeight(25)
	currencyFrame:SetWidth(100)
	currencyFrame:SetBackgroundColor(0,0,0,0)
	currencyFrame:SetLayer(10)


local curFrameCheck = false

function currency()
	if curFrameCheck == false then
		platFrame = UI.CreateFrame("Texture", "plat", currencyFrame)
		platAmountFrame = UI.CreateFrame("Text", "platAmount", currencyFrame)
		goldFrame = UI.CreateFrame("Texture", "gold", currencyFrame)
		goldAmountFrame = UI.CreateFrame("Text", "goldAmount", currencyFrame)
		silverFrame = UI.CreateFrame("Texture", "silver", currencyFrame)
		silverAmountFrame = UI.CreateFrame("Text", "silverAmount", currencyFrame)
		curFrameCheck = true
	end

	currencyTemp = Inspect.Currency.Detail("coin")


	if currencyTemp.stack ~= nil then
		len = string.len(currencyTemp.stack) -- we need this to determine how much currency we have
		local f = currencyFrame
		
		if len > 0 then
			silverAmountFrame:SetText(string.sub(currencyTemp.stack, len-1, len))	
			if len > 2 then
				goldAmountFrame:SetText(string.sub(currencyTemp.stack, len-3, len-2))
				if len > 4 then
					platAmountFrame:SetText(string.sub(currencyTemp.stack, 1, len-4))
				else
					platAmountFrame:SetText("0")
				end
			else
				goldAmountFrame:SetText("0")
				platAmountFrame:SetText("0")
			end
		else
			silverAmountFrame:SetText("0")
			goldAmountFrame:SetText("0")
			platAmountFrame:SetText("0")
		end
		
		--this is messy as shit and rediculously long do to not being able to format strings in pieces
		
		platFrame:SetTexture("nivStatsCurrency", "Textures\\plat.png")
		silverFrame:SetTexture("nivStatsCurrency", "Textures\\silver.png")
		goldFrame:SetTexture("nivStatsCurrency", "Textures\\gold.png")
		platFrame:SetPoint("CENTERLEFT", currencyFrame, "CENTERLEFT", 0, 0)
		platAmountFrame:SetPoint("CENTERLEFT", platFrame, "CENTERRIGHT", -2, 0)
		goldFrame:SetPoint("CENTERLEFT", platAmountFrame, "CENTERRIGHT", 2, 0)
		goldAmountFrame:SetPoint("CENTERLEFT", goldFrame, "CENTERRIGHT", -2, 0)
		silverFrame:SetPoint("CENTERLEFT", goldAmountFrame, "CENTERRIGHT", -2, 0)
		silverAmountFrame:SetPoint("CENTERLEFT", silverFrame, "CENTERRIGHT", -2, 0)
					
		currencyWidth = platFrame:GetWidth() + platAmountFrame:GetWidth() + goldFrame:GetWidth() + goldAmountFrame:GetWidth() + silverFrame:GetWidth() + silverAmountFrame:GetWidth()
		f:SetWidth(currencyWidth)
		f.Event.MouseIn = function(...) curMousein() end
		f.Event.MouseOut = function(...) curMouseout() end		
		
	end
end

local curToolTip = UI.CreateFrame("Frame","curToolTip",currencyFrame)

	
local pvp_icon = UI.CreateFrame("Texture","Favor Icon",curToolTip) 
local master_plaq = UI.CreateFrame("Texture","Master Craftsmen Mark",curToolTip)
local art_mark = UI.CreateFrame("Texture","Artisan Mark",curToolTip)
local planarite = UI.CreateFrame("Texture","Planarite",curToolTip)
local corr_ss = UI.CreateFrame("Texture","Corrupted Sourcestone",curToolTip)
local curse_ss = UI.CreateFrame("Texture","Cursed Sourcestone",curToolTip)
local vile_ss = UI.CreateFrame("Texture","Vile Sourcestone",curToolTip)
local in_ss = UI.CreateFrame("Texture","Inscribed Sourcestone",curToolTip)
local luck_coin = UI.CreateFrame("Texture","Lucky Coin",curToolTip)
local achieve_plaq = UI.CreateFrame("Texture","Plaque of Achievement",curToolTip)
local moa = UI.CreateFrame("Texture","Mark of Ascension",curToolTip)
local gmoa = UI.CreateFrame("Texture","Greater Mark of Ascension",curToolTip)
	
local favor = UI.CreateFrame("Text","Favor",curToolTip)
local master_plaq_text = UI.CreateFrame("Text","Master Craftsman's Mark",curToolTip)
local art_text = UI.CreateFrame("Text","Artisan's Mark",curToolTip)
local plan_text = UI.CreateFrame("Text","Planarite",curToolTip)
local corr_text = UI.CreateFrame("Text","Corrupted Sourcestone",curToolTip)
local curse_text = UI.CreateFrame("Text","Cursed Sourcestone",curToolTip)
local vile_text = UI.CreateFrame("Text","Vile Sourcestone",curToolTip)
local in_text = UI.CreateFrame("Text","Inscribed Sourcestone",curToolTip)
local luck_text = UI.CreateFrame("Text","Lucky Coin",curToolTip)
local ap_text = UI.CreateFrame("Text","Plaques of Achievement",curToolTip)
local moa_text = UI.CreateFrame("Text","Marks of Ascension",curToolTip)
local gmoa_text = UI.CreateFrame("Text","Greater Marks of Ascension",curToolTip)

local favor_amount = UI.CreateFrame("Text","Favor",curToolTip)
local master_amount = UI.CreateFrame("Text","Master Craftsman's Mark",curToolTip)
local art_amount = UI.CreateFrame("Text","Artisan's Mark",curToolTip)
local plan_amount = UI.CreateFrame("Text","Planarite",curToolTip)
local corr_amount = UI.CreateFrame("Text","Corrupted Sourcestone",curToolTip)
local curse_amount = UI.CreateFrame("Text","Cursed Sourcestone",curToolTip)
local vile_amount = UI.CreateFrame("Text","Vile Sourcestone",curToolTip)
local in_amount = UI.CreateFrame("Text","Inscribed Sourcestone",curToolTip)
local luck_amount = UI.CreateFrame("Text","Lucky Coin",curToolTip)
local ap_amount = UI.CreateFrame("Text","Plaques of Achievement",curToolTip)
local moa_amount = UI.CreateFrame("Text","Marks of Ascension",curToolTip)
local gmoa_amount = UI.CreateFrame("Text","Greater Marks of Ascension",curToolTip)

local curTipIcons = {
					pvp_icon, 
					master_plaq,
					art_mark,
					planarite,
					corr_ss,
					curse_ss,
					vile_ss,
					in_ss,
					luck_coin,
					achieve_plaq,
					moa,
					gmoa,
}

local curTipText = {
					favor,
					master_plaq_text,
					art_text,
					plan_text,
					corr_text,
					curse_text,
					vile_text,
					in_text,
					luck_text,
					ap_text,
					moa_text,
					gmoa_text,
}

local curTipAmount = {
					favor_Amount,
					master_plaq_Amount,
					art_Amount,
					plan_Amount,
					corr_Amount,
					curse_Amount,
					vile_Amount,
					in_Amount,
					luck_Amount,
					ap_Amount,
					moa_Amount,
					gmoa_Amount,
}

local curTipLength = table.maxn(curTipText)

function currencyToolTip()
	local x = currencyFrame:GetLeft() - T.nivStatsBar:GetLeft()
	local barWidth = T.nivStatsBar:GetRight() - T.nivStatsBar:GetLeft()
	if x < (barWidth/2) then
		if currencyFrame:GetTop() < 400 then
			curToolTip:ClearAll()
			curToolTip:SetPoint("TOPLEFT", currencyFrame, "BOTTOMLEFT", 0, 1)
			curToolTip:SetBackgroundColor(0, 0, 0, .5)
			curToolTip:SetHeight(305)
			curToolTip:SetWidth(300)
		else
			curToolTip:ClearAll()
			curToolTip:SetPoint("BOTTOMLEFT", currencyFrame, "TOPLEFT", 0, -1)
			curToolTip:SetBackgroundColor(0, 0, 0, .5)
			curToolTip:SetHeight(305)
			curToolTip:SetWidth(300)
		end
	else
		if currencyFrame:GetTop() < 400 then
			curToolTip:ClearAll()
			curToolTip:SetPoint("TOPRIGHT", currencyFrame, "BOTTOMRIGHT", 0, 1)
			curToolTip:SetBackgroundColor(0, 0, 0, .5)
			curToolTip:SetHeight(305)
			curToolTip:SetWidth(300)
		else
			curToolTip:ClearAll()
			curToolTip:SetPoint("BOTTOMRIGHT", currencyFrame, "TOPRIGHT", 0, -1)
			curToolTip:SetBackgroundColor(0, 0, 0, .5)
			curToolTip:SetHeight(305)
			curToolTip:SetWidth(300)
		end
	end
	curSetText()
	curSetAmount()
	curSetIcon()
end

function curSetText()
	favor:SetText("Favor: ")
	plan_text:SetText("Planarite: ")
	corr_text:SetText("Corrupted Sourcestones: ")
	curse_text:SetText("Cursed Sourcestones: ")
	vile_text:SetText("Vile Sourcestones: ")
	in_text:SetText("Inscribed Sourcestones: ")
	ap_text:SetText("Plaques of Achievement: ")
	moa_text:SetText("Marks of Ascension: ")
	gmoa_text:SetText("Greater Marks of Ascension: ")
	luck_text:SetText("Lucky Coins: ")
	master_plaq_text:SetText("Master Craftsman's Mark: ")
	art_text:SetText("Artisan's Mark: ")
	
	favor:SetPoint("CENTERLEFT",pvp_icon,"CENTERRIGHT",5,0)
	plan_text:SetPoint("CENTERLEFT",planarite,"CENTERRIGHT",5,0)
	corr_text:SetPoint("CENTERLEFT",corr_ss,"CENTERRIGHT",5,0)
	curse_text:SetPoint("CENTERLEFT",curse_ss,"CENTERRIGHT",5,0)
	vile_text:SetPoint("CENTERLEFT",vile_ss,"CENTERRIGHT",5,0)
	in_text:SetPoint("CENTERLEFT",in_ss,"CENTERRIGHT",5,0)
	ap_text:SetPoint("CENTERLEFT",achieve_plaq,"CENTERRIGHT",5,0)
	moa_text:SetPoint("CENTERLEFT",moa,"CENTERRIGHT",5,0)
	gmoa_text:SetPoint("CENTERLEFT",gmoa,"CENTERRIGHT",5,0)
	luck_text:SetPoint("CENTERLEFT",luck_coin,"CENTERRIGHT",5,0)
	master_plaq_text:SetPoint("CENTERLEFT",master_plaq,"CENTERRIGHT",5,0)
	art_text:SetPoint("CENTERLEFT",art_mark,"CENTERRIGHT",5,0)
end

local currTemp = {}
function GetStack(a)
	local list = Inspect.Currency.List()
    local stack = -1
	local stackMax = -1
    for k,j in pairs(list) do
        currTemp[j] = Inspect.Currency.Detail(k)
        if currTemp[j].name == a then
			if a == "Planarite" then
				stackMax = currTemp[j].stackMax
			end
            stack = currTemp[j].stack
            break
        else
            stack = 0
        end
    end
    if not stack then
        stack = -1
    end
	if a == "Planarite" then
		stack = tostring(stack) .. "/" .. tostring(stackMax)
	else
		stack = tostring(stack)
	end
	return stack
end

function curSetAmount()
    favor_amount:SetText(GetStack("Favor"))
    plan_amount:SetText(GetStack("Planarite"))
    master_amount:SetText(GetStack("Master Craftsman's Mark"))
    art_amount:SetText(GetStack("Artisan's Mark"))
    corr_amount:SetText(GetStack("Corrupted Sourcestone"))
    curse_amount:SetText(GetStack("Cursed Sourcestone"))
    vile_amount:SetText(GetStack("Vile Sourcestone"))
    in_amount:SetText(GetStack("Inscribed Sourcestone"))
    luck_amount:SetText(GetStack("Lucky Coin"))
    ap_amount:SetText(GetStack("Plaque of Achievement"))
    moa_amount:SetText(GetStack("Mark of Ascension"))
    gmoa_amount:SetText(GetStack("Greater Mark of Ascension"))
	
	favor_amount:SetPoint("TOPRIGHT",curToolTip,"TOPRIGHT",-5,5)
    plan_amount:SetPoint("TOPRIGHT",favor_amount,"TOPRIGHT",0,25)
    corr_amount:SetPoint("TOPRIGHT",plan_amount,"TOPRIGHT",0,25)
    curse_amount:SetPoint("TOPRIGHT",corr_amount,"TOPRIGHT",0,25)
    vile_amount:SetPoint("TOPRIGHT",curse_amount,"TOPRIGHT",0,25)
    in_amount:SetPoint("TOPRIGHT",vile_amount,"TOPRIGHT",0,25)
    ap_amount:SetPoint("TOPRIGHT",in_amount,"TOPRIGHT",0,25)
    moa_amount:SetPoint("TOPRIGHT",ap_amount,"TOPRIGHT",0,25)
    gmoa_amount:SetPoint("TOPRIGHT",moa_amount,"TOPRIGHT",0,25)
	luck_amount:SetPoint("TOPRIGHT",gmoa_amount,"TOPRIGHT",0,25)
	master_amount:SetPoint("TOPRIGHT",luck_amount,"TOPRIGHT",0,25)
    art_amount:SetPoint("TOPRIGHT",master_amount,"TOPRIGHT",0,25)

end

function curSetIcon()
	pvp_icon:SetHeight(20)
	planarite:SetHeight(20)
	corr_ss:SetHeight(20)
	curse_ss:SetHeight(20)
	vile_ss:SetHeight(20)
	in_ss:SetHeight(20)
	achieve_plaq:SetHeight(20)
	moa:SetHeight(20)
	gmoa:SetHeight(20)
	luck_coin:SetHeight(20)
	master_plaq:SetHeight(20)
	art_mark:SetHeight(20)
	
	pvp_icon:SetWidth(20)
	planarite:SetWidth(20)
	corr_ss:SetWidth(20)
	curse_ss:SetWidth(20)
	vile_ss:SetWidth(20)
	in_ss:SetWidth(20)
	achieve_plaq:SetWidth(20)
	moa:SetWidth(20)
	gmoa:SetWidth(20)
	luck_coin:SetWidth(20)
	master_plaq:SetWidth(20)
	art_mark:SetWidth(20)
	
	pvp_icon:SetTexture("Rift","item_icons\\trinket5.dds")
	planarite:SetTexture("Rift","item_icons\\planarite_orb_b.dds")
	corr_ss:SetTexture("Rift","item_icons\\sourcestone_04.dds")
	curse_ss:SetTexture("Rift","item_icons\\sourcestone_02z_z.dds")
	vile_ss:SetTexture("Rift","item_icons\\sourcestone_01.dds")
	in_ss:SetTexture("Rift","item_icons\\mystical_stone1.dds")
	achieve_plaq:SetTexture("Rift","item_icons\\plaque_of_achievement.dds")
	moa:SetTexture("Rift","item_icons\\card30c.dds")
	gmoa:SetTexture("Rift","item_icons\\card30a.dds")
	luck_coin:SetTexture("Rift","item_icons\\trinket8.dds")
	master_plaq:SetTexture("Rift","item_icons\\card28a.dds")
	art_mark:SetTexture("Rift","item_icons\\trinket27a.dds")
	
	pvp_icon:SetPoint("TOPLEFT",curToolTip,"TOPLEFT",5,5)
	planarite:SetPoint("TOPLEFT",pvp_icon,"BOTTOMLEFT",0,5)
	corr_ss:SetPoint("TOPLEFT",planarite,"BOTTOMLEFT",0,5)
	curse_ss:SetPoint("TOPLEFT",corr_ss,"BOTTOMLEFT",0,5)
	vile_ss:SetPoint("TOPLEFT",curse_ss,"BOTTOMLEFT",0,5)
	in_ss:SetPoint("TOPLEFT",vile_ss,"BOTTOMLEFT",0,5)
	achieve_plaq:SetPoint("TOPLEFT",in_ss,"BOTTOMLEFT",0,5)
	moa:SetPoint("TOPLEFT",achieve_plaq,"BOTTOMLEFT",0,5)
	gmoa:SetPoint("TOPLEFT",moa,"BOTTOMLEFT",0,5)
	luck_coin:SetPoint("TOPLEFT",gmoa,"BOTTOMLEFT",0,5)
	master_plaq:SetPoint("TOPLEFT",luck_coin,"BOTTOMLEFT",0,5)
	art_mark:SetPoint("TOPLEFT",master_plaq,"BOTTOMLEFT",0,5)
end

function curMousein()
	currencyToolTip()
	curToolTip:SetVisible(true)
end

function curMouseout()
	curToolTip:SetVisible(false)
end

table.insert(Event.System.Update.End, { currency, "nivStatsCurrency", "Refresh Modules" })
table.insert(Event.Currency, { currency, "nivStats", "Refresh Modules" })

local function nsCurLoad()
	if nivStatsCurrency_frameX then
		currencyFrame:ClearAll()
		currencyFrame:SetPoint("TOPLEFT", T.nivStatsBar, "TOPLEFT", nivStatsCurrency_frameX, nivStatsCurrency_frameY)
	else
		currencyFrame:ClearAll()
		currencyFrame:SetPoint("CENTER", T.nivStatsBar, "CENTER", 0, 0)
	end
	for k,v in pairs(Event.Addon.SavedVariables.Load.End) do
		if v[2] == "nivStatsCurrency" then
			eventID = k
		end
	end
	table.remove(Event.Addon.SavedVariables.Load.End, eventID)
end

local function nsCurSave()
	nivStatsCurrency_frameX = currencyFrame:GetLeft() - T.nivStatsBar:GetLeft()
	nivStatsCurrency_frameY = currencyFrame:GetTop() - T.nivStatsBar:GetTop()
end

table.insert(Event.Addon.SavedVariables.Save.Begin, {nsCurSave, "nivStatsCurrency", "Save"})
table.insert(Event.Addon.SavedVariables.Load.End, {nsCurLoad, "nivStatsCurrency", "Load"})