local addon = ...
local T, C, L = unpack(nivStats)

T.modules.vitalityFrame = UI.CreateFrame("Text", "Vitality", T.nivStatsBar)
local vitalityFrame = T.modules.vitalityFrame
vitalityFrame:SetPoint("CENTERRIGHT", T.nivStatsBar, "CENTERRIGHT", 0, 0)
vitalityFrame:SetLayer(2)
T.AddDragFrameMods(T.modules.vitalityFrame)

-- Vitality Module
function vitality()
	local temp = Inspect.Unit.Detail("player")
	if temp.vitality ~= nil then
		vitalityString = string.format("V: %d", temp.vitality)
		vitalityFrame:SetText(vitalityString)
		
		for k,v in pairs(Event.Unit.Available) do
			if v[2] == "nivStatsBags" then
				eventID = k
			end
		end
		table.remove(Event.Unit.Available, eventID)
	end
end

local function nsVitLoad()
	if nivStatsVitality_frameX then
		vitalityFrame:ClearAll()
		vitalityFrame:SetPoint("TOPLEFT", T.nivStatsBar, "TOPLEFT", nivStatsVitality_frameX, nivStatsVitality_frameY)
	else
		vitalityFrame:ClearAll()
		vitalityFrame:SetPoint("CENTERRIGHT", T.nivStatsBar, "CENTERRIGHT", 0, 0)
	end
	for k,v in pairs(Event.Addon.SavedVariables.Load.End) do
		if v[2] == "nivStatsVitality" then
			eventID = k
		end
	end
	table.remove(Event.Addon.SavedVariables.Load.End, eventID)
end

local function nsVitSave()
	nivStatsVitality_frameX = vitalityFrame:GetLeft() - T.nivStatsBar:GetLeft()
	nivStatsVitality_frameY = vitalityFrame:GetTop() - T.nivStatsBar:GetTop()
end

table.insert(Event.Addon.SavedVariables.Save.Begin, {nsVitSave, "nivStatsVitality", "Save"})
table.insert(Event.Addon.SavedVariables.Load.End, {nsVitLoad, "nivStatsVitality", "Load"})

table.insert(Event.Unit.Available, { vitality, "nivStatsVitality", "Refresh Vitality" })
